<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.CM.model.*"%>
<%@ page import="com.invoqsystems.integration.CM.util.ChangeManagementObjectWSUtil"%>
<%@ page import="org.dom4j.Node" %>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<%@ include file="configuration.jsp"%>

<%
String action = request.getParameter( "action" );
IncidentObject incident = (IncidentObject)session.getAttribute( "incident" );

if( incident != null )
{
  // Update the incident with all the changes
  Collection<String> keys = incident.getOriginalMap().keySet();

  // If this is create use the Web Service Fields as set to retrieve values.
  if ( "Create".equalsIgnoreCase( action ) )
  {
      keys = new ArrayList<String>();
      Map<String, String> wsFieldMap = ((IncidentCreation)incident).getWSFields();
      for ( String wsField : wsFieldMap.keySet() )
      {
          keys.add( wsFieldMap.get( wsField ) );
      }
  }
  for ( String key: keys )
  {
    if ( request.getParameterValues( key ) != null && request.getParameterValues( key ).length == 2 )
    {
      incident.addUpdate( key, "true" );
    }
    else if( request.getParameter( key ) != null )
    {
      incident.addUpdate( key, (String)request.getParameter( key ) );
    }
  }
}

if ( "Create".equalsIgnoreCase( action ) )
// We are trying to create a new incident
{
    ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
    ExternalServiceResponse resps;
    esr.setAction("createIncident");
    esr.addToken( "createFields", incident.getFields() );

    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%

    String incidentNumber = (String)resps.getResponse();
    String status;
    if ( !incidentNumber.startsWith( "CRQ" ) )
    {
        status = "?errorMessage="+(String)resps.getResponse();
        %>
        <jsp:forward page="<%=response.encodeURL("createIncident.jsp"+status)%>"/>
        <%
    }
    else
    {
      status = "&message=Success";
      %>
      <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentNumber="+incidentNumber+status)%>"/>
      <%
    }
}

else if( "Update".equalsIgnoreCase( action ) )
// We are trying to Update the Incident
{
  // Change the Priority if Urgency is changed
  String urgency = incident.getUpdateMap().get( "Urgency" );
  if ( urgency != null )
  {
      incident.addUpdate( "Weight", "0" );
      incident.addUpdate( "Priority", urgency.replaceAll("[0-9]+-","") );
  }
  %>
  <jsp:forward page="<%=response.encodeURL("diffIncident.jsp")%>"/>
  <%
}

else if( "Go".equalsIgnoreCase( action ) )
//We are trying to navigate to another page
{
%>
  <jsp:forward page="<%=response.encodeURL(request.getParameter("menuURL"))%>"/>
<%
}

else if ( "Add Info".equalsIgnoreCase( action ) )
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("addWorkInfo");

  Map<String, String> addInfoFields = new LinkedHashMap<String, String>();
  addInfoFields.put( "Communication_Source", "MobileGateway");
  addInfoFields.put( "Description", (String)incident.get("awi:::Description") );
  addInfoFields.put( "Detailed_Description", (String)incident.get("awi:::Detailed_Description") );
  addInfoFields.put( "Infrastructure_Change_ID", (String)incident.get("Infrastructure_Change_ID") );
  addInfoFields.put( "Secure_Work_Log", (String)incident.get("awi:::Secure_Work_Log") );
  addInfoFields.put( "View_Access", (String)incident.get("awi:::View_Access") );
  addInfoFields.put( "Work_Log_Date", "" );
  addInfoFields.put( "Work_Log_Type", "AlarmPoint");

  esr.addToken("addInfoFields", addInfoFields);
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%

  String workLogID = (String)resps.getResponse();
  String status;
  if ( !workLogID.startsWith( "CWL" ) )
  {
      status = "?errorMessage="+(String)resps.getResponse();
      %>
      <jsp:forward page="<%=response.encodeURL("updateIncident.jsp"+status)%>"/>
      <%
  }
  else
  {
    status = "&message=Work Info Added";
    %>
    <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?tab=work_info"+status)%>"/>
    <%
  }
}

else if ( "Add Approvers".equalsIgnoreCase( action ) )
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("addApprover");

  Map<String, String> addApproverFields = new LinkedHashMap<String, String>();
  String approvers = "";
  // build the approvers string
  if ((String)incident.get("ApproverGroup_ID") != "" && (String)incident.get("ApproverPerson_ID") != "") {
    approvers = (String)incident.get("ApproverPerson_ID") + "; " + (String)incident.get("ApproverGroup_ID") + " | CAB-Member";
  } else if ((String)incident.get("ApproverPerson_ID") != "") {
    approvers = (String)incident.get("ApproverPerson_ID");
  } else if ((String)incident.get("ApproverGroup_ID") != "") {
    approvers = (String)incident.get("ApproverGroup_ID") + " | CAB-Member";
  }

  String process = (String)incident.get("ApprovalProcessName");

  addApproverFields.put( "Approvers", approvers);
  addApproverFields.put( "Process", process );
  addApproverFields.put( "Status", "New");
  addApproverFields.put( "Req_ID", (String)incident.get("Request_ID") );

  esr.addToken("addApproverFields", addApproverFields);
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%

  // sleep, while the management system updates the ticket
  Thread.sleep(SLEEP_TIME_IN_MILLISECONDS);

  String reqID = (String)resps.getResponse();
  String status;
  if ( !reqID.startsWith( "00" ) )
  {
      status = "?errorMessage="+(String)resps.getResponse();
      %>
      <jsp:forward page="<%=response.encodeURL("updateIncident.jsp"+status)%>"/>
      <%
  }
  else
  {
    // clean up the incident to remove the saved approver information
    incident.getOriginalMap().put("ApproverGroup_ID","");
    incident.getOriginalMap().put("ApproverPerson_ID","");
    incident.getOriginalMap().put("ApproverGroup","");
    incident.getOriginalMap().put("ApproverPerson","");
    incident.addUpdate("ApproverGroup_ID","");
    incident.addUpdate("ApproverPerson_ID","");
    incident.addUpdate("ApproverGroup","");
    incident.addUpdate("ApproverPerson","");

    status = "&message=Approvers Added";
    %>
    <jsp:forward page="<%=response.encodeURL("updateIncident.jsp?tab=Approvers"+status)%>"/>
    <%
  }
}

else if ( "Resolve".equalsIgnoreCase( action ) )
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("resolveIncident");

  String incidentNumber = (String)incident.get("Infrastructure_Change_ID");

  Map<String, String> resolveFields = new LinkedHashMap<String, String>();
  resolveFields.put( "Infrastructure_Change_ID", (String)incident.get("Infrastructure_Change_ID"));
  resolveFields.put( "Resolution", (String)incident.get("Resolution:::Resolution"));
  resolveFields.put( "Resolution_Category", (String)incident.get("Resolution:::Resolution_Categorization:::Tier_1") );
  resolveFields.put( "Resolution_Category_Tier_2", (String)incident.get("Resolution:::Resolution_Categorization:::Tier_2") );
  resolveFields.put( "Resolution_Category_Tier_3", (String)incident.get("Resolution:::Resolution_Categorization:::Tier_3") );
  resolveFields.put( "Resolution_Method", (String)incident.get("Resolution:::Resolution_Method") );
  resolveFields.put( "Status", "Resolved" );
  resolveFields.put( "Status_Reason", (String)incident.get("resolve:::Status_Reason") );
  resolveFields.put( "z1D_Action", "MODIFY" );

  esr.addToken("resolveFields", resolveFields);
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%

  String exception = (String)resps.getResponse();
  String status;
  if ( exception != null && exception.length() > 0 )
  {
      status = "?errorMessage="+exception;
      %>
      <jsp:forward page="<%=response.encodeURL("updateIncident.jsp"+status)%>"/>
      <%
  }
  else
  {
    // Each time we change tab or re-visit this tab, we want to clear the values
    incident.getOriginalMap().put("resolve:::Resolution","");
    incident.getOriginalMap().put("resolve:::Status_Reason","");
    incident.getOriginalMap().put("resolve:::Resolution_Category","");
    incident.getOriginalMap().put("resolve:::Resolution_Category_Tier_2","");
    incident.getOriginalMap().put("resolve:::Resolution_Category_Tier_3","");
    incident.getOriginalMap().put("resolve:::Resolution_Method","");
    incident.addUpdate("resolve:::Resolution","");
    incident.addUpdate("resolve:::Status_Reason","");
    incident.addUpdate("resolve:::Resolution_Category","");
    incident.addUpdate("resolve:::Resolution_Category_Tier_2","");
    incident.addUpdate("resolve:::Resolution_Category_Tier_3","");
    incident.addUpdate("resolve:::Resolution_Method","");

    status = "&message=Incident Resolved";
    %>
    <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentNumber="+incidentNumber+"&tab=details"+status)%>"/>
    <%
  }
}


else
{
    Enumeration<String> parameterNames = request.getParameterNames();
    while ( parameterNames.hasMoreElements() )
    {
      String field = parameterNames.nextElement();
      String key = field.replaceFirst(".*-", "");
      String pageURL = request.getParameter("pageURL");
      String tab = request.getParameter("tab");
      if ( tab == null )
      {
          tab = "";
      }

      if ( field.startsWith( "searchCustomer" ) )
      {
        String searchUrl = "searchCustomer.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchGroupApprover" ) )
      {
        String searchUrl = "searchGroupApprover.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchPersonApprover" ) )
      {
        String searchUrl = "searchPersonApprover.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchGroup" ) )
      {
        String searchUrl = "searchGroup.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchProdCat" ) )
      {
        String searchUrl = "searchProdCat.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchOpCat" ) )
      {
        String searchUrl = "searchOpCat.jsp?url="+pageURL+"&tab="+tab;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchReason" ) )
      {
        Map<String, Map<String, String>> staticListIDMap =
            (Map<String, Map<String, String>>)application.getAttribute("staticListIDMap");
        String status = (String)incident.get( "Status" );
        if ( "resolve:::Status_Reason".equals(key) )
        {
            status = "Resolved";
        }
        String statusID = staticListIDMap.get("Status").get(status);
        String searchUrl = "searchReason.jsp?url="+pageURL+"&tab="+tab+"&field="+key+"&statusID="+statusID;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchChangeManagerGroup" ) )
      {
        String searchUrl = "searchChangeManagerGroup.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchChangeManager" ) )
      {
        String searchUrl = "searchChangeManager.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchChangeAssignee" ) )
      {
        String searchUrl = "searchChangeAssignee.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchAssignee" ) )
      {
        String searchUrl = "searchAssignee.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchCompany" ) )
      {
        String searchUrl = "searchCompany.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchResolutionCause" ) )
      {
        String searchUrl = "searchResolutionCause.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchResolutionMethod" ) )
      {
        String searchUrl = "searchResolutionMethod.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }
      else if ( field.startsWith( "searchResolutionCat" ) )
      {
        String searchUrl = "searchResolutionCat.jsp?url="+pageURL+"&tab="+tab+"&field="+key;
        %>
          <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
        <%
      }

    }
}
%>
