<%
Map<String, Object> listValues = (Map<String, Object>)application.getAttribute("listValues");

Map<String, List<String>> staticLists = (Map<String, List<String>>)application.getAttribute("staticLists");
Map<String, Map<String, String>> staticListIDMap = (Map<String, Map<String, String>>)application.getAttribute("staticListIDMap");

Date lastUpdate = (Date)application.getAttribute("listValuesTimestamp");
Date now = new Date();
if( lastUpdate == null || now.getTime() - lastUpdate.getTime() > CM_LISTS_EXPIRED )
{
  listValues = null;
}

if ( listValues == null )
{
  listValues = new HashMap<String, Object>();
  // Get Product Categorization
  try
  {
    String prefix = com.invoqsystems.integration.CM.util.ChangeManagementObjectWSUtil.RESPOND_PREFIX;

    Map<String, String> listFields = new LinkedHashMap<String, String>();
    listFields.put( "Qualification", "" );
    listFields.put( "startRecord", "" );
    listFields.put( "maxLimit", "" );

    // Product Categorization
    //
    String operation = "APINT_PC_QueryList";
    String service = "APINT_PCT_ProductCatalog_WS";
    ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
    ExternalServiceResponse resps;
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction("queryNode");
    esr.addToken( "operation", operation );
    esr.addToken( "webService", service );
    esr.addToken( "requestNS", service );
    esr.addToken( "responseNS", service );
    esr.addToken( "fields", listFields );
    %>
    <%@ include file="sendRequest.jsp"%>
    <%
    Node node = (Node)resps.getResponse();
    listValues.put( "ProductCategorization",
               ProductCategorizationTier.buildTiers( prefix, node ) );

    // Operational Categorization
    //
    operation = "APINT_SC_QueryList";
    service = "APINT_CFG_ServiceCatalog_WS";
    esr = mobileGatewaySession.createExternalServiceRequest();
    esr.setAction("queryNode");
    esr.addToken( "operation", operation );
    esr.addToken( "webService", service );
    esr.addToken( "requestNS", service );
    esr.addToken( "responseNS", service );
    esr.addToken( "fields", listFields );
    %>
    <%@ include file="sendRequest.jsp"%>
    <%
    node = (Node)resps.getResponse();
    listValues.put( "OperationalCategorization",
    OpCategorizationTier.buildTiers( prefix, node ) );
  }
  catch ( Exception ex )
  {
      out.println( ex.toString() );
  }

  //Set the application attributes so these lists can be cached and shared between sessions
  application.setAttribute("listValues", listValues);
  application.setAttribute("listValuesTimestamp", new Date());
}

if ( staticLists == null )
{
  staticLists = new HashMap<String, List<String>>();
  staticListIDMap = new HashMap<String, Map<String, String>>();

  application.setAttribute( "staticLists", staticLists );
  application.setAttribute( "staticListIDMap", staticListIDMap );

  // Add the values for the Status field
  List<String> statusList =
      Arrays.asList( new String[] {
        "Draft",
        "Request For Authorization",
        "Request For Change",
        "Planning In Progress",
        "Scheduled For Review",
        "Scheduled For Approval",
        "Scheduled",
        "Implementation In Progress",
        "Pending",
        "Rejected",
        "Completed",
        "Closed",
        "Cancelled"
  });
  staticLists.put( "Status", statusList );
  Map<String, String> statusIDMap = new HashMap<String,String>();
  statusIDMap.put( "Draft", "0" );
  statusIDMap.put( "Request For Authorization", "1" );
  statusIDMap.put( "Request For Change", "2" );
  statusIDMap.put( "Planning In Progress", "3" );
  statusIDMap.put( "Scheduled For Review", "4" );
  statusIDMap.put( "Scheduled For Approval", "5" );
  statusIDMap.put( "Scheduled", "6" );
  statusIDMap.put( "Implementation In Progress", "7" );
  statusIDMap.put( "Pending", "8" );
  statusIDMap.put( "Rejected", "9" );
  statusIDMap.put( "Completed", "10" );
  statusIDMap.put( "Closed", "11" );
  statusIDMap.put( "Cancelled", "12" );
  staticListIDMap.put( "Status", statusIDMap );

  // Add the values for the Impact field
  List<String> impactList =
      Arrays.asList( new String[] {
        "1-Extensive/Widespread",
        "2-Significant/Large",
        "3-Moderate/Limited",
        "4-Minor/Localized"
  });
  staticLists.put( "Impact", impactList );

  // Add the values for the Urgency field
  List<String> urgencyList =
      Arrays.asList( new String[] {
        "1-Critical",
        "2-High",
        "3-Medium",
        "4-Low"
  });
  staticLists.put( "Urgency", urgencyList );

  // Add the values for the Service Type field
  List<String> serviceTypeList =
      Arrays.asList( new String[] {
        "User Service Restoration",
        "User Service Request",
        "Infrastructure Restoration",
        "Infrastructure Event"
  });
  staticLists.put( "Service_Type", serviceTypeList );

  // Add the values for Yes/No fields
  List<String> yesNoList =
      Arrays.asList( new String[] {
        "No",
        "Yes"
  });
  staticLists.put( "YesNo", yesNoList );

  //Add the values for View Access fields
  List<String> viewAccessList =
      Arrays.asList( new String[] {
        "Public",
        "Internal"
  });
  staticLists.put( "ViewAccess", viewAccessList );

  //Add the values for Closure Source fields
  List<String> closureSource =
      Arrays.asList( new String[] {
        "Customer",
        "System",
        "Support Agent"
  });
  staticLists.put( "ClosureSource", closureSource );

  //Add the values for Reported Source fields
  List<String> reportedSource =
      Arrays.asList( new String[] {
        "",
        "Direct Input",
        "Email",
        "External Escalation",
        "Fax",
        "Systems Management",
        "Phone",
        "Voice Mail",
        "Walk In",
        "Web",
        "Other"
  });
  staticLists.put( "ReportedSource", reportedSource );


  //Add the values for Change Type fields
  List<String> changeType =
      Arrays.asList( new String[] {
        "Change",
        "Project",
        "Release",
        "Asset Configuration",
        "Asset Management",
        "Asset Lease",
        "Purchase Requisition",
        "Asset Maintenance"
  });
  staticLists.put( "ChangeType", changeType );

  //Add the values for Risk Level fields
  List<String> riskLevel =
      Arrays.asList( new String[] {
        "Risk Level 1",
        "Risk Level 2",
        "Risk Level 3",
        "Risk Level 4",
        "Risk Level 5"
  });
  staticLists.put( "RiskLevel", riskLevel );

  //Add the values for Priority fields
  List<String> priority =
      Arrays.asList( new String[] {
        "Critical",
        "High",
        "Medium",
        "Low"
  });
  staticLists.put( "Priority", priority );

  //Add the values for Change Timing fields
  List<String> changeTiming =
      Arrays.asList( new String[] {
        "Normal",
        "Emergency",
        "Expedited",
        "Latent",
        "No Impact"
  });
  staticLists.put( "ChangeTiming", changeTiming );

  //Add the values for Business_Justification fields
  List<String> businessJustification =
      Arrays.asList( new String[] {
        "",
        "Corporate Strategic",
        "Business Unit Strategic",
        "Maintenance",
        "Defect",
        "Upgrade",
        "Enhancement",
        "Customer Commitment",
        "Sarbanes-Oxley"
  });
  staticLists.put( "BusinessJustification", businessJustification );

  //Add the values for Change Reason fields
  List<String> changeReason =
      Arrays.asList( new String[] {
        "",
        "Fix/Repair",
        "New Functionality",
        "Maintenance",
        "Upgrade",
        "Other"
  });
  staticLists.put( "ChangeReason", changeReason );

  //Add the values for Environment fields
  List<String> environment =
      Arrays.asList( new String[] {
        "",
        "Production",
        "Model Office",
        "Hot Backup",
        "Development"
  });
  staticLists.put( "Environment", environment );


  //Add the values for TimingReason fields
  List<String> timingReason =
      Arrays.asList( new String[] {
        "",
        "Customer/business need",
        "Insufficient lead-time",
        "Known error correction",
        "Scheduling conflict"
  });
  staticLists.put( "TimingReason", timingReason );
}
%>