<%
int start = 0;
session.setAttribute("incidentHeaders", incidentHeaders);
if(incidentHeaders == null || incidentHeaders.isEmpty())
{
  out.print("<div class=\"msg-warning\">No Results Returned</div>");
}
else if(incidentHeaders.size() == 1)
{
  String id = (String)incidentHeaders.get(0).get("Infrastructure_Change_ID");
  %>
  <jsp:forward page="<%=response.encodeURL("loadIncident.jsp?IncidentNumber="+id)%>"/>
  <%
}
else
{
  %>
  <table>
    <tr>
      <th>CR#</th>
      <th>Impact</th>
      <th>Urgency</th>
      <th>Summary</th>
    </tr>
    <%
    if( request.getParameter("page") != null )
      start = RESULTS_PER_PAGE * Integer.valueOf( request.getParameter("page") );
    int end = start + RESULTS_PER_PAGE;

    if ( incidentHeaders.size() < end )
    {
      end = incidentHeaders.size();
    }

    Collection<GenericWSObject> list = incidentHeaders.subList( start, end );
    for ( GenericWSObject header : list )
    {
      String id = (String)header.get("Infrastructure_Change_ID");
      java.util.regex.Pattern p = java.util.regex.Pattern.compile( "([A-Za-z]+)[0]+([0-9]+)" );
      java.util.regex.Matcher match = p.matcher( id );
      String displayId = id;
      if ( match.find() && match.groupCount() == 2 )
      {
          displayId = match.group(1)+match.group(2);
      }

      String impact = (String)header.get("Impact");
      String displayImpact = impact;
      if ( impact.equalsIgnoreCase( "1-Extensive/Widespread" ) )
          displayImpact = "1-Ext/Wd";
      else if ( impact.equalsIgnoreCase( "2-Significant/Large" ) )
          displayImpact = "2-Sig/Lrg";
      else if ( impact.equalsIgnoreCase( "3-Moderate/Limited" ) )
          displayImpact = "3-Mod/Ltd";
      else if ( impact.equalsIgnoreCase( "4-Minor/Localized" ) )
          displayImpact = "4-Min/Loc";

      String urgency = (String)header.get("Urgency");
      String displayUrgency = urgency;
      if ( urgency.equalsIgnoreCase( "1-Critical" ) )
          displayUrgency = "1-Crit";
      else if ( urgency.equalsIgnoreCase( "2-High" ) )
          displayUrgency = "2-Hgh";
      else if ( urgency.equalsIgnoreCase( "3-Medium" ) )
          displayUrgency = "3-Med";

      String desc = (String)header.get("Description");
      String link = "loadIncident.jsp?IncidentNumber=" + id;
      String encodedLink = response.encodeURL(link);

      // trim summary
      if (desc.length() > MAX_SUMMARY_DISPLAY_IN_CHARACTERS) {
        desc = desc.substring(0, (MAX_SUMMARY_DISPLAY_IN_CHARACTERS));
      }
    %>
    <tr>
      <td><a href="<%=encodedLink%>"><%=displayId%></a></td>
      <td><%=displayImpact%></td>
      <td class="urg-<%=urgency%>"><%=displayUrgency%></td>
      <td><%=desc%></td>
    </tr>
    <%
    }
    %>
  </table>
  <%
  int count = 0;

  // Only show the page numbers if there is more than 1 page of results
  if (incidentHeaders.size() > RESULTS_PER_PAGE) {
    for( int i = 0; i < incidentHeaders.size(); i+=RESULTS_PER_PAGE )
    {
      if(i == start)
        out.println(count+1);
      else
        out.println("<a href=\""+response.encodeURL(pageURL+"?page="+count)+"\">"+(count+1)+"</a>");
      count++;
    }
  }
}
%>