<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.CM.model.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<%@ include file="configuration.jsp"%>

<html>
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");

      table td.urg-1-Critical {
        background: #990033;
        font-weight: bold;
        color: #FFFFFF;
        white-space: nowrap;
      }

      table td.urg-2-High {
        background: #0000CC;
        font-weight: bold;
        color: #FFFFFF;
        white-space: nowrap;
      }

      table td.urg-3-Medium {
        background: #FFFFEE;
        white-space: nowrap;
      }

      table td.urg-4-Low {
        background: #FFFFFF;
        white-space: nowrap;
      }
    </style>
  </head>

  <body>
    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
      <%
      String message = "";
      String pageURL = "queryIncidents.jsp";
      List<GenericWSObject> incidentHeaders = (List)session.getAttribute( "incidentHeaders" );
      if( incidentHeaders == null )
      {
          incidentHeaders = new ArrayList<GenericWSObject>();
      }
      String attributeName = (String)request.getParameter( "listAttribute" );
      String title = "List Incidents";
      if ( attributeName != null && attributeName.length() > 0 )
      {
        title = attributeName;
        attributeName = (String)request.getParameter( "listAttribute" );
        incidentHeaders = (List<GenericWSObject>)session.getAttribute( attributeName );
      }
      if( request.getParameter("queryString") != null )
      {
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction( "getIncidentHeaders" );
        esr.addToken( "Qualification", (String)request.getParameter( "queryString" ) );
        %>
        <%@ include file="includes/sendRequest.jsp"%>
        <%
        if( resps.getResponse() instanceof String )
        {
          message = "<div class=\"msg-error\">"+resps.getResponse()+"</div>";
        }
        else if ( resps.getResponse() != null )
        {
            incidentHeaders = (List<GenericWSObject>)resps.getResponse();
        }
      }
      %>
      <H1><%=title%> [<%=incidentHeaders.size()%>]</H1>
    </div>
    <div id="content">
      <%=message%>
      <%@ include file="includes/tableOfIncidents.jsp"%>
    </div>
    <div id="footer">
      <div class="footer-links">
        <a href="<%=response.encodeURL("menu.jsp")%>">CM Menu</a>&nbsp;-&nbsp;
        <%@ include file="includes/standardFooterLinks.jsp"%>
      </div>
  </body>
</html>