<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<html>
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      div.section-header {
        font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;
        font-size: 1.3em;
        font-weight: bold;
        background-color: #4180CE;
        color: #FFF;
        text-align: center;
        border: solid #666;
        border-width: 1px 1px 2px 1px;
        padding: 3px 2px 3px 2px;
      }
    </style>
  </head>

  <body>
    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
      <H1>Query Help</H1>
    </div>
    <div id="content">
      <div class="section-header">Steps</div>
      <p>To search for Change Requests:</p>
      <table>
        <tr>
          <td>1</td>
          <td>In the Field drop-down list, select a change request detail.</td>
        </tr>
        <tr>
          <td>2</td>
          <td>In the Op drop-down list, select a search operator. (See list of Operators below.)</td>
        </tr>
        <tr>
          <td>3</td>
          <td>In the Value field, type a string or other Remedy ARS-style qualification. (See list of Qualification Styles below.)</td>
        </tr>
        <tr>
          <td>4</td>
          <td>Repeat for additional change request details and values to narrow your search results.</td>
        </tr>
        <tr>
          <td>5</td>
          <td>Click Submit Query.</td>
        </tr>
      </table>
      <div class="msg-warning">Note: Query results include only those Change Requests that match ALL specified search criteria.</div>
      <div class="section-header">Operators</div>
      <table>
        <tr>
          <th>Op</th>
          <th>Description</th>
        </tr>
        <tr>
          <td>like</td>
          <td>Like</td>
        </tr>
        <tr>
          <td>eq</td>
          <td>Equals</td>
        </tr>
        <tr>
          <td>not</td>
          <td>Not Equals</td>
        </tr>
        <tr>
          <td>lt</td>
          <td>Less than</td>
        </tr>
        <tr>
          <td>lte</td>
          <td>Less than or equal to</td>
        </tr>
        <tr>
          <td>gt</td>
          <td>Greater than</td>
        </tr>
        <tr>
          <td>gte</td>
          <td>Greater than or equal to</td>
        </tr>
      </table>
      <div class="section-header">Qualification Styles</div>
      <table>
        <tr>
          <th>Strings</th>
          <td>Strings must be enclosed in quotation marks; e.g., "Urgent".</td>
        </tr>
        <tr>
          <td></td>
          <td>Wildcards (represented by the % character) are supported only with the 'like' operator.</td>
        </tr>
        <tr>
          <th>Keywords</th>
          <td>Keywords and numbers should not be enclosed in quotation marks.</td>
        </tr>
        <tr>
          <td>$NULL$</td>
          <td>A constant representing no value.</td>
        </tr>
        <tr>
          <td>$DATE$</td>
          <td>A constant representing the current date, with a time of 00:00:00.</td>
        </tr>
        <tr>
          <td>$TIMESTAMP$</td>
          <td>A constant representing the current date and time.</td>
        </tr>
      </table>
      <div class="section-header">List Items</div>
      <div class="msg-warning">Change Request details that are lists cannot be searched using the "like" operator, but items within the lists can be represented using their respective IDs, as described in the following tables.</div>
      <table>
        <tr>
          <th colspan="2">Change Type</th>
        </tr>
        <tr>
          <td>Project</td>
          <td>1000</td>
        </tr>
        <tr>
          <td>Change</td>
          <td>2000</td>
        </tr>
        <tr>
          <td>Release</td>
          <td>3000</td>
        </tr>
        <tr>
          <td>Asset Configuration</td>
          <td>4000</td>
        </tr>
        <tr>
          <td>Asset Management</td>
          <td>5000</td>
        </tr>
        <tr>
          <td>Asset Lease</td>
          <td>6000</td>
        </tr>
        <tr>
          <td>Purchase Requisition</td>
          <td>7000</td>
        </tr>
        <tr>
          <td>Asset Maintenance</td>
          <td>8000</td>
        </tr>
        <tr>
          <th colspan="2">Status</th>
        </tr>
        <tr>
          <td>Draft</td>
          <td>0</td>
        </tr>
        <tr>
          <td>Request For Authorization</td>
          <td>1</td>
        </tr>
        <tr>
          <td>Request For Change</td>
          <td>2</td>
        </tr>
        <tr>
          <td>Planning In Progress</td>
          <td>3</td>
        </tr>
        <tr>
          <td>Scheduled For Review</td>
          <td>4</td>
        </tr>
        <tr>
          <td>Scheduled For Approval</td>
          <td>5</td>
        </tr>
        <tr>
          <td>Scheduled</td>
          <td>6</td>
        </tr>
        <tr>
          <td>Implementation In Progress</td>
          <td>7</td>
        </tr>
        <tr>
          <td>Pending</td>
          <td>8</td>
        </tr>
        <tr>
          <td>Rejected</td>
          <td>9</td>
        </tr>
        <tr>
          <td>Completed</td>
          <td>10</td>
        </tr>
        <tr>
          <td>Closed</td>
          <td>11</td>
        </tr>
        <tr>
          <td>Cancelled</td>
          <td>12</td>
        </tr>
        <tr>
          <th colspan="2">Risk Level</th>
        </tr>
        <tr>
          <td>Risk Level 1</td>
          <td>0</td>
        </tr>
        <tr>
          <td>Risk Level 2</td>
          <td>1</td>
        </tr>
        <tr>
          <td>Risk Level 3</td>
          <td>2</td>
        </tr>
        <tr>
          <td>Risk Level 4</td>
          <td>3</td>
        </tr>
        <tr>
          <td>Risk Level 5</td>
          <td>4</td>
        </tr>
        <tr>
          <th colspan="2">Impact</th>
        </tr>
        <tr>
          <td>1-Extensive/Widespread</td>
          <td>1000</td>
        </tr>
        <tr>
          <td>2-Significant/Large</td>
          <td>2000</td>
        </tr>
        <tr>
          <td>3-Moderate/Limited</td>
          <td>3000</td>
        </tr>
        <tr>
          <td>4-Minor/Localized</td>
          <td>4000</td>
        </tr>
        <tr>
          <th colspan="2">Urgency</th>
        </tr>
        <tr>
          <td>1-Critical</td>
          <td>1000</td>
        </tr>
        <tr>
          <td>2-High</td>
          <td>2000</td>
        </tr>
        <tr>
          <td>3-Medium</td>
          <td>3000</td>
        </tr>
        <tr>
          <td>4-Low</td>
          <td>4000</td>
        </tr>
        <tr>
          <th colspan="2">Priority</th>
        </tr>
        <tr>
          <td>Critical</td>
          <td>0</td>
        </tr>
        <tr>
          <td>High</td>
          <td>1</td>
        </tr>
        <tr>
          <td>Medium</td>
          <td>2</td>
        </tr>
        <tr>
          <td>Low</td>
          <td>3</td>
        </tr>
        <tr>
          <th colspan="2">Change Timing</th>
        </tr>
        <tr>
          <td>Emergency</td>
          <td>1000</td>
        </tr>
        <tr>
          <td>Expedited</td>
          <td>2000</td>
        </tr>
        <tr>
          <td>Latent</td>
          <td>3000</td>
        </tr>
        <tr>
          <td>Normal</td>
          <td>4000</td>
        </tr>
        <tr>
          <td>No Impact</td>
          <td>5000</td>
        </tr>
      </table>
      <div class="section-header">Examples</div>
      <table>
        <tr>
          <th colspan="2">Example 1: Querying for all Change Requests where "Smith" is the Change Manager</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Manager</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>like</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>"%Smith%"</td>
        </tr>
        <tr>
          <td colspan="2">Note: The % character is interpreted as a wildcard.</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 2: Querying for all Change Requests of Medium or higher Urgency </th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Urgency</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>lte</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>"3-Medium"</td>
        </tr>
        <tr>
          <td colspan="2">Note: Urgency is compared using its List ID, where 2-High and 1-Critical have Priority values of 2000 and 1000, respectively.</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 3: Querying for Change Requests with Status prior to being Scheduled.</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Status</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>lt</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>"Scheduled For Review"</td>
        </tr>
      </table>
      <table>
        <tr>
          <th colspan="2">Example 4: Querying for Change Requests with Change Timing of Emergency</th>
        </tr>
        <tr>
          <th>Field</th>
          <td>Chg Timing</td>
        </tr>
        <tr>
          <th>Op</th>
          <td>eq</td>
        </tr>
        <tr>
          <th>Value</th>
          <td>"Emergency"</td>
        </tr>
      </table>
      <div class="msg-warning">For more information, see the Remedy WorkFlow Objects manual.</div>
      <a href="<%=response.encodeURL("queryIncidents.jsp")%>">Back</a>
    </div>
    <div id="footer">
    <div class="footer-links">
      <a href="<%=response.encodeURL("menu.jsp")%>">CM Menu</a>&nbsp;-&nbsp;
      <%
      if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
      {
      %> <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp; <%
      }
      %>
      <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a></div>
    </div>
  </body>
</html>
