<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.CM.model.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<%
Map<String, String> searchFields = new LinkedHashMap<String, String>();
searchFields.put("Company", "Company");
searchFields.put("Full Name", "Full Name");
%>

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
        font-weight: bold;
        color: #990033;
      }
    </style>
  </head>

  <body>
    <%
    String field = (String)request.getParameter("field");
    String url = (String)request.getParameter("url");
    String tab = (String)request.getParameter("tab");
    %>
    <form name="form" action="<%=response.encodeURL("searchChangeManager.jsp?field="+field+"&url="+url+"&tab="+tab)%>" method="POST">
      <div id="header">
        <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
        <h1>Search Change Manager</h1>
      </div>
      <div id="content">
        <%
        if ( request.getParameter("assignee") != null && url != null && field != null )
        {
          String target = "SearchChangeManager";
          String company = (String)request.getParameter("company");
          String supportOrganization = (String)request.getParameter("supportOrganization");
          String supportGroupName = (String)request.getParameter("supportGroupName");
          String assignee = (String)request.getParameter("assignee");
          String supportGroupID = (String)request.getParameter("supportGroupID");
          String loginID = (String)request.getParameter("loginID");



          if ( session.getAttribute("incident") != null )
          {
            Map<String,List<String>> autoFills = (Map<String,List<String>>)session.getAttribute("autoFillFields");
            List<String> fields = autoFills.get( target );
            IncidentObject incident = (IncidentObject)session.getAttribute("incident");
            incident.addUpdate( fields.get(0), company );
            incident.addUpdate( fields.get(1), supportOrganization );
            incident.addUpdate( fields.get(2), supportGroupName );
            incident.addUpdate( fields.get(3), assignee );
            incident.addUpdate( fields.get(4), supportGroupID );
            incident.addUpdate( fields.get(5), loginID );
          }
          %>
            <jsp:forward page="<%=response.encodeURL(url+"?tab="+tab)%>"/>
          <%
        }
        else if ( request.getParameter("searchValue") != null &&
                  !"".equals(request.getParameter("searchValue") ) )
        {
          QueryObject query = new QueryObject();
          QueryField queryField = new QueryField();
          queryField.setField( (String)request.getParameter( "searchField" ) );
          queryField.setOperator( new QueryLogic( (String)request.getParameter("searchOperator") ) );
          queryField.setValue((String)request.getParameter("searchValue"));
          query.getFields().add( queryField );

          String qual = query.getQualification() + "AND ( 'Status-SGP' = \"Enabled\") AND ( 'Status-SGR' = \"Enabled\") AND ( 'FunctionalRole' =  \"CAB-Manager\" ) AND ( 'Assignment Availability' = \"Yes\")";

          ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
          ExternalServiceResponse resps;
          esr.setAction("queryGenericList");
          esr.addToken( "service","ChangeManager" );
          esr.addToken( "Qualification", qual );
          %>
          <%@ include file="includes/sendRequest.jsp"%>
          <%
          List<GenericWSObject> people = new ArrayList<GenericWSObject>();
          if(resps.getResponse() instanceof String)
          {
            if (!((String)resps.getResponse()).equals("JavaException: java.lang.Exception: WS Fault: soapenv:Server.userException || ERROR (302): Entry does not exist in database; ")) {
              %>
              <%@ include file="includes/searchErrorMsg.jsp"%>
              <%
            }
          }
          else if ( resps.getResponse() != null )
          {
            people = (List<GenericWSObject>)resps.getResponse();
          }
          if ( people.size() == 0 )
          {
            out.print("<div class=\"msg-warning\">No Results Found</div>");
          }
          else
          {
            %>
            <table>
              <tr>
                <th>Com</th>
                <th>Grp</th>
                <th>Name</th>
              </tr>
              <%
              for( GenericWSObject person : people )
              {
                %>
                <tr>
                  <td><%=person.get("Company")%></td>
                  <td><%=person.get("Support_Group_Name")%></td>
                  <td><a href="<%=response.encodeURL("searchChangeManager.jsp?field="+
                          field+
                          "&url="+url+
                          "&tab="+tab+
                          "&company=" + person.get("Company") +
                          "&supportOrganization=" + person.get("Support_Organization") +
                          "&supportGroupName=" + person.get("Support_Group_Name") +
                          "&supportGroupID=" + person.get("Support_Group_ID") +
                          "&loginID=" + person.get("Login_ID") +
                          "&assignee=" + person.get("Full_Name") )%>">
                          <%=person.get("Full_Name")%></a></td>
                </tr>
                <%
              }
              %>
            </table>
          <%
          }
          %>
          <a href="<%=response.encodeURL("searchChangeManager.jsp?field="+field+"&url="+url+"&tab="+tab)%>">Search Again</a>
          <%
        }
        else
        {
          QueryLogic operatorTemplate = new QueryLogic();
          %>
          <table>
            <tr>
              <th>Field</th>
              <th>Op</th>
              <th>Value</th>
            </tr>
            <tr>
              <td>
                <select name="searchField">
                  <%
                  for(String fld : searchFields.keySet())
                  {
                  %>
                  <option value="<%=fld%>"><%=searchFields.get(fld)%></option>
                  <%
                  }
                  %>
                </select>
              </td>
              <td>
                <select name="searchOperator">
                  <%
                  for( String operator : operatorTemplate.getOperatorMap().keySet() )
                  {
                  %>
                  <option value="<%=operator%>"><%=operator%></option>
                  <%
                  }
                  %>
                </select>
              </td>
              <td>
                <input type="text" name="searchValue" size="10" value='"%"'/>
              </td>
            </tr>
          </table>
          <input type="submit" name="search" value="Search"/>
          <%
        }
        %>
      </div>
    </form>
    <a href="<%=response.encodeURL(url+"?tab="+tab)%>">Back to Details</a>

    <div id="footer">
      <div class="footer-links">
        <a href="<%=response.encodeURL("menu.jsp")%>">CM Menu</a>&nbsp;-&nbsp;
        <%
        if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
        {
          %>
          <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp;
          <%
        }
        %>
        <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a>
      </div>
    </div>
  </body>
</html>