<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.invoqsystems.integration.CM.model.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>AlarmPoint Mobile Gateway</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/alarmpoint/logo.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/general.css");
      label.required {
        font-weight: bold;
        color: #990033;
      }
    </style>
  </head>

  <body>
    <%
    String url = (String)request.getParameter("url");
    String tab = (String)request.getParameter("tab");
    String field = (String)request.getParameter("field");
    %>
    <form name="form" action="<%=response.encodeURL("searchProdCat.jsp?url="+url+"&tab="+tab+"&field="+field)%>" method="POST">
      <div id="header">
        <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
        <h1>Search Prod Cat</h1>
      </div>
      <div id="content">
        <%
        if( (request.getParameter("done") != null || request.getParameter("prod") != null ) && url != null && field != null )
        {
          String targetFill = "ProdCat";
          if ( field.startsWith("Resolution:::") )
          {
            targetFill = "ResolutionProdCat";
          }
          String t1 = (String)request.getParameter("tier1");
          String t2 = (String)request.getParameter("tier2");
          String t3 = (String)request.getParameter("tier3");
          String manufacturer = (String)request.getParameter("man");
          String product = (String)request.getParameter("prod");
          if( session.getAttribute("incident") != null )
          {
            Map<String,List<String>> autoFills = (Map<String,List<String>>)session.getAttribute("autoFillFields");
            List<String> fields = autoFills.get( targetFill );
            IncidentObject incident = (IncidentObject)session.getAttribute("incident");
            incident.addUpdate( fields.get(0), t1 );
            incident.addUpdate( fields.get(1), t2 );
            incident.addUpdate( fields.get(2), t3 );
            incident.addUpdate( fields.get(3), manufacturer );
            incident.addUpdate( fields.get(4), product );
          }
          %>
          <jsp:forward page="<%=response.encodeURL(url+"?tab="+tab)%>"/>
          <%
        }
        else if( request.getParameter("searchValue") != null &&
                !"".equals( request.getParameter("searchValue") ) )
        {
          String t1 = (String)request.getParameter("tier1");
          String t2 = (String)request.getParameter("tier2");
          String t3 = (String)request.getParameter("tier3");

          String searchValue = (String)request.getParameter("searchValue");

          Map<String, Object> lists = (Map<String,Object>)application.getAttribute("listValues");
          List topTiers = (List)lists.get("ProductCategorization");

          boolean searchProduct = ( t3 != null && t3.length() > 0 );

          List<?> objects;
          if ( searchProduct )
          {
              objects = ProductCategorizationTier.searchProducts( topTiers,
                      Arrays.asList( new String[]{ t1, t2, t3 }), searchValue);
          }
          else
          {
              objects = ProductCategorizationTier.getTiers( topTiers,
                      Arrays.asList( new String[]{ t1, t2, t3 }), searchValue);
          }

          if ( objects.size() == 0 )
          {
            out.print("<div class=\"msg-warning\">No Results Found</div>");
          }
          else
          {
            %>
            <table>
              <%@ include file="includes/currentTiers.jsp"%>
              <%
              if ( searchProduct )
              {
                %><%@ include file="includes/productsResults.jsp"%><%
              }
              else
              {
                %><%@ include file="includes/tiersResults.jsp"%><%
              }
            %>
            </table>
          <%
          }
          %>
          <a href="<%=response.encodeURL("searchProdCat.jsp?url="+url+"&tab="+tab+"&field="+field)%>">Search Again</a>
          <%
        }
        else
        {
          String t1 = (String)request.getParameter("tier1");
          String t2 = (String)request.getParameter("tier2");
          String t3 = (String)request.getParameter("tier3");

          String searchFieldLabel = "Tier 1";
          if ( t3 != null && t3.length() > 0 )
          {
              searchFieldLabel = "Product";
          }
          else if ( t2 != null && t2.length() > 0 )
          {
            searchFieldLabel = "Tier 3";
          }
          else if ( t1 != null && t1.length() > 0 )
          {
              searchFieldLabel = "Tier 2";
          }

          %>
          <table>
            <%@ include file="includes/currentTiers.jsp"%>
          </table>
          <table>
            <tr>
              <th>Field</th>
              <th>Op</th>
              <th>Value</th>
            </tr>
            <tr>
              <td><%=searchFieldLabel%></td>
              <td>like</td>
              <td>
                <input type="text" name="searchValue" size="10" value='"%"'/>
              </td>
            </tr>
            <tr>
              <td colspan="3" class="no-border">
                <input type="submit" name="search" value="Search"/>
                <input type="submit" name="done" value="Done"/>
              </td>
            </tr>
          </table>
          <%
          if ( t1 != null && t1.length() > 0 )
          {
            %><input type=hidden name="tier1" value="<%=t1%>"/><%
          }
          if ( t2 != null && t2.length() > 0 )
          {
            %><input type=hidden name="tier2" value="<%=t2%>"/><%
          }
          if ( t3 != null && t3.length() > 0 )
          {
            %><input type=hidden name="tier3" value="<%=t3%>"/><%
          }
        }
        %>
      </div>
    </form>
    <a href="<%=response.encodeURL(url+"?tab="+tab)%>">Back to Details</a>

    <div id="footer">
      <div class="footer-links">
        <a href="<%=response.encodeURL("menu.jsp")%>">CM Menu</a>&nbsp;-&nbsp;
        <%
        if(mobileGatewaySession.getUser().getAccessibleServices().size() > 1)
        {
          %>
          <a href="<%=response.encodeURL("../listServices.jsp")%>">Services</a>&nbsp;-&nbsp;
          <%
        }
        %>
        <a href="<%=response.encodeURL("../logout.jsp")%>">Logout</a>
      </div>
    </div>
  </body>
</html>